## AUTO LOAD LIBRARY
##  by Shin-ichiro HARA
##
##  version 1.1 (2001.11.14)
##

class Module
  def auto_load(*syms)
    file = syms.pop
    syms.each do |symb|
      module_eval <<-__CODE__
      unless defined? AUTO_LOAD
	AUTO_LOAD = {}
	def method_missing(sym, *param, &block)
	  begin
	    unless file = AUTO_LOAD[sym]
	      raise NameError,
		"undefined method `\#{sym.id2name}' for \#{inspect}"
	    end
	    require file
	    unless respond_to?(sym, true)
	      raise "auto_load: `\#{sym.id2name}' is not defined in `#{file}'"
	    end
	    send(sym, *param, &block)
	  rescue Exception
	    $@.delete_if{|trace| trace =~ /^\\(eval\\):/}
	    raise
	  end
	end
      end
      AUTO_LOAD[symb.is_a?(String) ? symb.intern : symb] = file
      __CODE__
    end
  end
end

def auto_load(*a, &b)
  type.auto_load(*a, &b)
end

if $0 == __FILE__
  class Foo
    auto_load(:hello, "hello.rb")
  end
  Foo.new.hello
  Foo.new.bye
end
